Welcome

1ExAlgo - this is a universal complex for working with all types of trading robots, testing and managing them.
Inside 1ExAlgo you will find:
  • 1.
    About 100 free robots on the platform at once. View the entire list
  • 2.
    Development of robots according to your logic or you can make a robot yourself.
  • 3.
    Free use of the program for 2 weeks;
  • 4.
    Simultaneous trading on multiple accounts;
  • 5.
    Simultaneous operation of several tens or hundreds of robots;
  • 6.
    The processing speed of the algorithm of one robot is from 0.2 msec;
  • 7.
    Testing of the algorithm on historical data and selection of optimal parameters for each tool;
  • 8.
    And this is not all the features of the platform!
Connect 1ExAlgo to your favorite platform
and, of course, with the most popular crypto exchanges (the list is constantly updated)
System requirements:
  • •
    Processor is no worse than Pentium 4 (2.0 GHz),
  • •
    RAM at least 4 GB (8 GB recommended),
  • •
    15 GB of free hard disk space,
  • •
    Operating system Windows 10, Windows Server 2016, 2019 and above,
  • •
    64 bit system
  • •
    Under Windows 7, the system works, except for the ability to connect to crypto exchanges
  • •
    The Microsoft NET 6 component (you can download it for free from the official Microsoft website).


How it works

Just 5 steps and you trade and earn with 1ExAlgo robots..
  • 1.
    Installation
  • 2.
    Registration and authorization
  • 3.
    Connection
  • 4.
    Choosing a strategy
  • 5.
    Testing
and now you can launch combat trading!
But first, a guide to the interface..


Interface Guide

1. Version and tariff. Find out more about the rates
2. Main menu.
  • •
    Connections
  • •
    Tools
  • •
    Modules
  • •
    Tables
  • •
    Settings
  • •
    Reference
3. Tabs, all open windows are in tabs.
4. General menu of buttons for working with robots, modules and other platform pages (different depending on the open page).
5. List of robots. In particular, the MA robot is open in the image, many robots have been created in it (this is the list we see), two robots are running and trading.
6. The chart for the selected work (the image shows quotes for the selected instrument (ETH / USB)).
7. The trading data window, there are its own tabs (open positions, journal, trades, statistics for the day, emulation trades).


Registration and authorization

×

  • Registration and authorization
  • Предыдущая
  • Следующая
Registration and authorization
To register, you need to fill in the email that has not yet been used to register the program and click the "Register" button. If the registration window is closed, click "Connection" in the top menu./Registration/Authorization".
After that, the password required for authorization will be sent to the mail. This login and password pair will be used for authorization every time 1ExAlgo is launched. After entering the password, you need to click the "Log in" button. After authorization, the previously mentioned restrictions will be lifted, and if the launch is for the first time, then demo access is activated for 14 days, it gives all the features of the Pro tariff, i.e. all the features of the program.
Your E-mail and the current tariff will be displayed in the header of the 1ExAlgo program.
If you need to activate the license, then you need to open the menu "Settings"/License Management" and enter the activation code.

Содержание Registration and authorization

Installation


Installation

×

  • Registration and authorization
  • Installation
  • Предыдущая
  • Следующая
Installation
Download the latest version of the platform from the main page of the site 1exalgo.com and run the file 1exalgosetup.exe.
Click the "Next" button
Note (Select) "I accept the terms of the agreement", click "Next"
Click the "Next" button
(If necessary, create an icon on the Desktop) Click the "Next" button
Click the "Install" button


Connection selection

×

  • Connection selection
  • Предыдущая
  • Следующая
Connection selection
Depending on where you trade - choose the connection.
QUIK, Transaq Connector, Ib Tws - accounts should already be installed and opened, your broker will help you with this.
Crypto exchanges - a personal account must be opened, i.e. all the necessary verifications for a particular exchange have been completed.

Содержание Connection selection

Connecting a crypto exchange
Configuring the Transaq Connector
Setting IbTws
Connecting to QUIK


Connecting a crypto exchange

×

  • Connection selection
  • Connecting a crypto exchange
  • Предыдущая
  • Следующая
Connecting a crypto exchange
The process of connecting to any crypto exchange is the same.
1. In 1ExAlgo: In 1ExAlgo: "Connections/Establish a connection", a crypto exchange is selected and available.
2. Setting up connection parameters.
3. Next, you need to enter the public key and the secret key. You can create them on your crypto exchange account.
4. Select the connector operation mode. The “Public” mode does not require keys, you can write any data, i.e. the data provided by the exchange (Glass, Tape of transactions, Quotes on pairs, historical data) will be received.
If necessary, perform the operation, you will need to select the “Private” mode and enter the valid keys.
5. We add the necessary tools by ticking them off - they are transferred from left to right.
6. Click the Connection/Establish a connection, the connection status will change to green.


Configuring the Transaq Connector

×

  • Connection selection
  • Configuring the Transaq Connector
  • Предыдущая
  • Следующая
Configuring the Transaq Connector
Access to the Transaq Connector is provided by the broker. You can connect it through your personal account.
In 1ExAlgo, the menu item "Connections/Terminals". Next, select the terminal type Transaq Connector.
2. Add a new terminal.
Name | Description
Name | Optional field. You can get information from where to get the IP and other useful information about the IP for the user.
IP address | By default.
Port | By default.
Login | It is not necessary to fill them in, you can fill them in when you connect.
Password | It is not necessary to fill them in, you can fill them in when you connect.
Parameters of Finam trading servers
Main address: tr1.finam.ru , port: 3900;
Backup address: tr2.finam.ru , port: 3900.
Parameters of trading servers of Bank Finam
Main address: tr1.finambank.ru , port: 3324.
Backup address: tr2.finambank.ru , port: 3324
Important! If the connection to Transaq Connector is made for the first time, and you have not traded through it before, then you will need to change your username and password through the program after establishing a connection to perform operations.


Setting IbTws

×

  • Connection selection
  • Setting IbTws
  • Предыдущая
  • Следующая
Setting IbTws
1. In the Ib Tws terminal, go to the File / Global Configuration menu.
2. In the window that opens:
  • •
    API / Settings section.
  • •
    Activate ActiveX and socket clients - the check mark must be set;
  • •
    Api, read-only - the check mark should be unchecked;
  • •
    Socket-port 7497 - must match the settings in 1ExAlgo.
    The rest of the settings remain by default.
3. Settings in 1ExAlgo: Connection section/Terminals and in the window that opens, IbTws is selected.
4. The "Add a new terminal" window.
5. - add the tool you are interested in..
Name | Description
Symbol code | The code in IbTws. For futures, need to specify only two letters.
Symbol type | STK - stocks, FUT - futures.
Currency | The monetary unit in which the symbol is calculated.
Primary Exchange | The main platform from which quotes for the symbol are received.
Exchange | By default, you can leave SMART or use the same platform as Primary exchange.
Multiplier | Not a required field, but for some symbols, if they have the same ticker, you need to specify a multiplier "Multiplier".
Price step | For correct calculation, it is necessary to specify the minimum step of the tool.
Expiration date | The date of execution of the futures or options.
Margin collateral | Margin for futures or option.
Strike | The exercise price of the option.
6. After setting up the tools and the trading terminal, click Connections/Establish a connection.


Connecting to QUIK

×

  • Connection selection
  • Connecting to QUIK
  • Предыдущая
  • Следующая
Connecting to QUIK
Creating a connection in 1ExAlgo:
1. The Quik trading terminal to which you plan to connect must be turned off. After starting 1ExAlgo, you need to go to the menu item "Connection"/ "Terminals"
2. A list of all possible connections that can be created is visible on the right. The type of Quik terminal is selected, the window "Adding connections and configuring Quik" will appear. At the same time, the program can work with 10 Quik and an unlimited number of accounts in these trading terminals.
If the number of Quik's connected at the same time is more than 1, then in order to optimize the information received, it is recommended to leave the "Table of current parameters" and "Table of all transactions" in only one Quik, in the rest Quik, close it.
3. The folder with the working windows file can be opened immediately, it will need to be uploaded to Quik after the connection is established. To connect Quik, you need to specify the path to the folder where the file is located info.exe . If the path is specified correctly, then after specifying the path to the terminal, the "Set Settings" button will become active.
After that, run Quick. Go to the menu "System" / "Download settings from file", select the settings template (located in the folder where 1ExAlgo is installed (..\1ExAlgo\Setting for terminals or this folder was opened from the menu earlier ) and click Upload, and additional tables will be added to the settings on a separate tab.
Important! The program receives only the information that is transmitted from the terminal. Therefore, it is necessary to add the instruments that will be traded to the table of current parameters. It is also necessary to add information to the "Table of all transactions" for the same instruments. If a tick chart is not being built, then data will not be received in the table of all transactions. In this case, you need to contact your broker and ask him to connect tick charts. And don't forget to change the dark to light theme in quick via the System menu/Settings/Main/Program/The theme of the design.


Job selection

A robot is an automated strategy. Choose your robot or trade several at once.
Don't know which strategy to start with? It's better to start with simple robots, by the type of MA - Moving average, study how it works, in 1ExAlgo there is a link to information on this strategy in front of each strategy.
  • 1.
    ADX50
  • 2.
    AdxMa
  • 3.
    AdxTS
  • 4.
    Alligator
  • 5.
    Arbitrage
  • 6.
    ArbitrageV2
  • 7.
    AvgVolume
  • 8.
    BbOpenClose (Bollinger Bands)
  • 9.
    BbOpenClose2 (Bollinger Bands 2)
  • 10.
    BbOpenCloseRevers (Bollinger bands reverse)
  • 11.
    BbOpenCloseRevers2 (Bollinger bands reverse 2)
  • 12.
    BbOpenProboyRevers (Bollinger bands breakdown reverse)
  • 13.
    BbProboy (Bollinger bands breakdown)
  • 14.
    BbProboy2 (Bollinger bands breakdown 2)
  • 15.
    BollingerRsi
  • 16.
    BullishHarami
  • 17.
    CandleRobot
  • 18.
    CandleRobot2 (Three candles in a row)
  • 19.
    CciDivergence
  • 20.
    CCIStochMa
  • 21.
    ChaikinVolatility
  • 22.
    DarkCloudCover
  • 23.
    DoubleChannel
  • 24.
    EldersScreens
  • 25.
    EnvelopesClose
  • 26.
    EnvelopesOpenClose2
  • 27.
    EnvelopesOpenClose3
  • 28.
    Fibo
  • 29.
    FractalChannel
  • 30.
    FractalChannelOneOpen
  • 31.
    GravestoneDoji
  • 32.
    Guide
  • 33.
    Hammer
  • 34.
    HangingMan
  • 35.
    HorizonalLevel
  • 36.
    HorizonalLevelCandle
  • 37.
    HorizonalLevelOtboy
  • 38.
    Levels (Уровни)
  • 39.
    LindaRashke
  • 40.
    LongLeggedDoji
  • 41.
    MA (Moving Averages)
  • 42.
    MA2 (4 Moving Averages)
  • 43.
    MA4 (Moving Averages 4)
  • 44.
    MAandMacd
  • 45.
    MaAndPrice (Moving average and price)
  • 46.
    MaAndPriceRevers (Moving average and price. Reverse.)
  • 47.
    MacdAo
  • 48.
    MacdChange
  • 49.
    MacdDivergence (Macd divergence)
  • 50.
    MacdEma
  • 51.
    MacdHistChange
  • 52.
    MacdHistLevel
  • 53.
    MacdLevel (Macd level)
  • 54.
    MacdRobot (A robot based on the MACD indicator)
  • 55.
    MacdSar
  • 56.
    Martingail
  • 57.
    MartingailV2
  • 58.
    MMF (Moving Averages and fractal)
  • 59.
    OneTwoThree
  • 60.
    ParabolicSarRsi
  • 61.
    PercentChange
  • 62.
    PinBar
  • 63.
    PirceChannelOtboy (Channel abort)
  • 64.
    PirceChannel Proboy (Channel breakdown)
  • 65.
    PirceChannel Proboy2 (Channel breakdown 2)
  • 66.
    PirceChannel Proboy3 (Channel breakdown 3)
  • 67.
    PirceChannel Proboy4 (Channel breakdown 4)
  • 68.
    PirceChannel_Proboy5Close (Channel breakdown on closing)
  • 69.
    PrevDayClose
  • 70.
    Renko
  • 71.
    RisingThreeMethods
  • 72.
    RsiDivergence (RSI divergence)
  • 73.
    RsiRobot (Robot by indicator RSI)
  • 74.
    RsiSarRobot (RSI + filter SAR)
  • 75.
    RsiSarRobot2 (RSI + filter SAR 2)
  • 76.
    SarRobot (Parabolic SAR)
  • 77.
    SarRobot2 (Parabolic SAR 2)
  • 78.
    SarRobot2Profit (Robot SAR 2 + Profit)
  • 79.
    SecondInstrSignal
  • 80.
    StochasticAdxMa
  • 81.
    StochasticCross (Stochastic intersection)
  • 82.
    StochasticCrossAndLevel (Stochastic intersection and level)
  • 83.
    StochasticCrossAndLevelProboy (Stochastic intersection and breakdown)
  • 84.
    StochasticLevel (Stochastic and zones)
  • 85.
    ThreeWhiteSoldiers
  • 86.
    TrendMomentum
  • 87.
    TrendNRTR
  • 88.
    Triangle
  • 89.
    VolCandle
  • 90.
    WillamR1Cross (WillamR intersection)
  • 91.
    WilliamsSar

Содержание Job selection

Working with robots
The inside of the robot


Working with robots

Have you decided on a strategy? Then it's time to launch your first robot!
Through the "strategies" section, new works are uploaded, deleted, and launched in 1ExAlgo. Just click on the required strategy, confirm the actions and you will be taken to the strategies tab.
The number of strategies and robots with various settings, traded instruments and accounts, you can create and run any number (there are restrictions depending on the type of license for 1ExAlgo). The more robots are running at the same time and the more complex the algorithm, the more time it takes to process the information. Depending on the power of the computer, the complexity of the strategy and the number of robots, the time spent on processing all robots according to the launched strategy will be different and it is displayed to the left of the [image] button in milliseconds. The average processing time of the robot algorithm is 0.2-0.4 milliseconds, depending on the power of the computer and the complexity of the algorithm.
- uploading a strategy, scanner, portfolio script or user statistics (a file with the cs extension) to the selected directory or via the context menu. Scanners, portfolio scripts and user statistics are automatically moved to the appropriate folder. For more information about the strategy loading procedure, see the section "Loading and deleting strategies";
- delete the selection script;
- протестировать выделенную стратегию;
- запустить выделенную стратегию;
- create a strategy container (to transfer the strategy to another person, with a closed code);
- load the strategy container;
- Click if you want to start the robot, the robot is disabled in this position of the toggle switch, click on this toggle switch opposite each robot that needs to be started.
- The color of the button changes to green as the status of the robot being launched changes. And as soon as the information appears in the "Price" and "Post. change" columns, trading will begin. To stop the robot, you need to press the green button again.
- Tap to launch all robots at once.
- Tap to stop all robots.
1. List of robots. The list is presented in the form of a table. There can be up to 15 columns in the table, they can be customized for themselves, the columns themselves represent the settings selected in the robot and indicators.
2. Table variables and values. The table is located to the right of the list of robots for the launched strategy. In this area, you can output additional information from the robot code, for example, the calculation of a variable or a value. For convenience, there is a graph tab in the table.
3. Trading information. For visual control of the robots are presented: Open positions, journal, transactions, statistics for the day, emulation transactions.


The inside of the robot

×

  • Job selection
  • The inside of the robot
  • Предыдущая
  • Следующая
The inside of the robot
We will see tabs inside any robot:
  • •
    Basic settings (account, instrument, position size, timeframe);
  • •
    Robot and/or Indicators (work strategy settings);
  • •
    Service (additional thin buns for setting up);
  • •
    Stop orders (stop limit, profit, trailing profit, etc.);
  • •
    Risks (built-in risk manager);
  • •
    Time (work time management).

Содержание The inside of the robot

Basic Settings
Robot and indicators
Stop orders
Risks
Time


Basic Settings

Recommended. During the initial acquaintance with the robot and its settings, it is recommended to choose the virtual trading mode. When the robot is first launched in automatic trading mode, it is recommended to use either a demo account (for the concept of how the robot trades and checking the correctness of the settings) or, if the account is "combat", it is recommended to set the position size fixed, equal to 1 contract / lot. After you have mastered the management, you can switch to the "normal" trading mode, with your settings.
We fill in the basic data for the job
Name - choose any name for your robot
Account - it is on it that trading will be conducted
Trading mode: Virtual mode - the robot simulates real trading (you trade - you learn - you don't spend money), Real - it's also a combat mode, with sending orders to the exchange.
Type of trade - choosing the direction of trade. "Long and Short" - the robot opens long and short positions.
Symbol - the code of the instrument that will be used for trading.
Class - the code of the instrument class, the trading section in which the instrument is located.
Position size The number of contracts/lots that will be used to open a position is determined depending on the "Position Size" settings. Here the source of the deposit, the initial deposit and other values are displayed.
Timeframe - the period of the interval. Possible options: ticks, seconds, minutes, days, weeks and months.


Robot and indicators

The "robot" tab displays variables that the user can change. The number and types of configurable parameters depend on the developer of the trading algorithm, if there are no parameters to configure, then this tab will not be displayed.
If the indicators embedded in 1ExAlgo by default are used in trading, then it will be possible to configure it on this tab. If the indicators are not used in the work, then this tab will be missing.
Each robot is unique, study how the strategy of your chosen robot works, experiment with the settings in virtual mode, look at what affects the change of a parameter in the robot.


Stop orders

Types of stop orders:
Stop limit - a stop order is used to fix losses. If the price changes towards a loss by a specified amount, the position will be closed.
Profit (limit order) - a limit order is used to fix profits, in the case of using a virtual profit, it is worth considering the following. Conditions for triggering an order, for example, +10 points from the opening price of the transaction, as soon as the price is +10 points, the order will go to the trading terminal. If the order is market, then there will be execution at the price of demand (for example, the best prices of supply and demand in a glass of 120 and 130. The closing of a long position will be at the price of 120, i.e., in fact, the conditions are met, and in this case no profit is received due to the large spread in the glass).
Stop limit and profit - stop limit and profit are used (limit order)
Trelling profit is an opportunity to allow profits to grow and in case of deviation from the maximum profit value in transactions by a given amount and close the position.
Trelling profit and Stop Limit - Stop limit and trelling profit are used.
Example of stop limit operation
Initial data: Deviation=30, Spread=5, Calculation price - signal price.
The opening of the position was at the price of 57288, from this price the value of the price at which the stop order will be placed is calculated: the price of the stop order = the price of opening the position - Deviation * the minimum price step = 57288-30*1 =57258. When the stop order is activated, the exchange order will be placed at the price of 57258-spread * minimum price step =57258-5*1=57253, and its execution will be at the best price on the market. If the spread is "small" or the market is highly volatile, then the order may remain standing in the DOM.


Risks

Built into each job is a Risk manager. For each robot, you can set your own risk limits for the day, upon reaching which it will stop trading before the end of the day or for a specified pause. Adds peace of mind to trading, with the risk settings set, you can safely leave the robot to trade without your control, knowing that, for example, it will not merge the deposit, but will stop at a certain minus value.
Type of risk
Profit - Upon reaching the specified profit, further trading will be prohibited today. Closes all positions and, if possible, removes all orders and stop orders. If this value is zero, it does not participate in the calculations
Drawdown - When the specified loss is reached, further trading will be prohibited today. Closes all positions and, if possible, removes all orders and stop orders. If this value is zero, it does not participate in the calculations
Trailing return - Designed to save profits. Example: Activation of 5000 $, deviation 1500 $, the trelling profit will take effect when the profit reaches the mark of 5000 $, then the offset begins to count from this value and the termination of trading will occur at around 3500 $. If a new profit maximum is reached, then the calculation will be carried out from it, i.e. a profit of 5500 $ is reached, then the trading will stop at around 4000 $.
Profit Protection - Designed to protect profits. Example: Activation of 3000 $, Protection level of 2000 $, protection will take effect when the profit reaches the mark of 3000 $ and in case of a decrease in profit to 2000 $, trading will be prohibited. Unlike trelling, the protection level will always be in one place after activation, no matter what the profit received. In this case, trading can be continued until the profit decreases to 2000 $.
And also the risk values..
Account balance, fixed profit, profit (Fact), loss, fixed loss, loss (Fact.), trelling profit fixed, trelling profit (Fact.), profit protection fixed, profit protection (Fact.), number of transactions, number of unprofitable transactions, unprofitable transactions in a row, profitable transactions in a row.


Time

The time settings allow you to configure the robot to work at a certain time and make it possible to close positions on the robot before the end of the session. You can configure the robot's operating time for each day individually, or set several trading time intervals for one day.
Type of action - what happens when the ordered time comes
  • •
    Discovery\Closing a position
  • •
    Closing a position
  • •
    Opening a position
  • •
    Withdrawal and forced closure


Backtest

In this section, it is possible to test and optimize the strategy on historical data. If the strategy uses for analysis: the price of the last transaction, the amount of supply and demand, or data from the glasses, then such strategies can be tested only in real time, either in "automatic" mode with real bids on the exchange or in virtual mode - the mode of emulation of transactions, without sending them to the exchange.
Strategies whose algorithms are based on the analysis of candlesticks, indicators, various patterns and conditions can be analyzed (tested) on historical data, pre-loading them into "Data Sources", or on "Data from storage" - the history accumulated during real trading.

Содержание Backtest

Data sources
Test run and results
Optimization


Data sources

Data sources are used for testing on history and automatic history loading.
Tools\Data sources. In the left part there are created sources, it is recommended that the name should contain the timeframe and the source from where they were downloaded. In the right part there is information about the location of the files.
This section is intended for one-time download or automatic download of historical data for testing. On the left side there are Exchanges and sources from which you can download historical data.
To download data, you need to click "Upload data" through the context menu.
Downloading Data from a Crypto exchange
Connect to the crypto
exchange "Tools/ Data Sources".
Either through the menu or through the context menu – the "Add" menu item
  • 1.
    We select the instruments of interest for which we need to get historical data and transfer them to the column of traded instruments.
  • 2.
    Enter the name of this source (the name can be any, the main thing is that it is clear to you)
  • 3.
    Select: Timeframe, period – for which we will upload historical data and tools
  • 4.
    The rest can not be changed.
  • 5.
    Through the context menu, select "Upload data"


Test run and results

×

  • Backtest
  • Test run and results
  • Предыдущая
  • Следующая
Test run and results
Preparing for testing
1. Choose a strategy for testing. Click and make a choice. Make adjustments, if necessary, to the strategy in the Parameters. In the left part of the testing section, select the tool that you plan to test, it is automatically inserted into the robot.
2. Choose the testing period
3. Select the data for testing
4. Click on the "Start" button
Test results
Chart. The chart of the instrument on which the test is being conducted is displayed, as well as indicators and all additional lines that the strategy developer provided for displaying on the chart. Instead of the time of the chart, the axis of the candle numbers is located at the bottom of it. The numbering goes from 0 to the current candle on the chart.
Statistics
The resulting information on trading strategies based on historical data. In the "All" column, information on all transactions is displayed, in the "Purchases" column, only information on Long transactions is displayed, in the "Sales" column, only information on Short transactions is displayed, in the "Buy and Hold" column, information about what would have happened with one transaction at the beginning of the test period is displayed.
Transactions
According to the test results, all transactions that have been made, as well as detailed information on them, will appear in this section.
Quick transition to the deal on the chart: when you double-click on the arrow with the left mouse button, a chart will open, where the leftmost deal will be the one on which you double-clicked.
Yield and drawdown
The yield graph shows the growth and fall of the capital curve.
The drawdown chart shows the maximum decrease in funds on the account as a percentage. If the initial capital is 0, then the absolute value will be displayed, and if set, then as a percentage, relative to the initial capital.


Optimization

Optimization is the process of selecting a set of parameters in order to increase the efficiency (profitability and stability) of the results of a trading system.
The optimization section displays the strategy parameters that can be optimized.
The "Start optimization" button starts the process of iterating through the parameters. As the optimization progresses, the Results window will appear next to the Optimization window. The results of the system testing are entered in the "Results". Double-clicking on the results of interest will give detailed statistics - it will automatically substitute the parameters into a regular test and run the test.
You can also use advanced optimization features:
  • •
    Adding a timeframe;
  • •
    Adding a tool;
  • •
    Using the statistics script.


Many possibilities

  • •
    Robot management
  • •
    Robot Portfolio
  • •
    Containers
  • •
    Notifications
  • •
    Data storage
  • •
    Portfolio testing
  • •
    Forward testing
  • •
    Open API